-- Testbench circuit for VOTE3CS
--    (c) J. Dean Brock, 2004
--    EXCEPT for CONV_STD_LOGIC function taken from
--      John Wakerly, Digital Design: Principles and Practices 
library ieee ;
use ieee.std_logic_1164.all ;

entity VOTE3CS_tb is
    generic (whocares : boolean := true) ;
end VOTE3CS_tb ;
  
architecture TESTBENCH of VOTE3CS_tb IS
  component VOTE3CS IS
    port (
    X  : in  STD_LOGIC;
    Y  : in  STD_LOGIC;
    Z  : in  STD_LOGIC;
    M  : out STD_LOGIC
  ) ;
  end component ;

  constant period : time := 200 ns ;

  signal TestIn  : STD_LOGIC_VECTOR (0 to 2) ;
  signal TestOut : STD_LOGIC ;
  
  -- The CONV_STD_LOGIC function is taken from
  --      John Wakerly, Digital Design: Principles and Practices 
  function CONV_STD_LOGIC_VECTOR(ARG: integer; SIZE: integer)
                     return STD_LOGIC_VECTOR is
    variable result: STD_LOGIC_VECTOR (SIZE-1 downto 0) ;
    variable temp: integer ;
  begin
    temp := ARG ;
    for i in 0 to SIZE-1 loop
      if (temp mod 2) = 1 then
        result(i) := '1' ;
      else
        result(i) := '0' ;
      end if ;
      temp := temp / 2 ;
    end loop ;
    return result ;
  end ; 

begin  -- TESTBENCH
  TestMod: VOTE3CS
    port map (
      X   => TestIn(0) ,
      Y   => TestIn(1) ,
      Z   => TestIn(2) ,
      M   => TestOut
   ) ;

   TestLoop: process
   begin
     while (true) loop
       for i in 0 to 7 loop
       	 TestIn <= CONV_STD_LOGIC_VECTOR(i, 3) ;
       	 wait for period ;
       end loop ;
     end loop ;
   end process ;
	

end TESTBENCH;


